scala.tools.nsc.typechecker.AnalyzerPlugins

# AnalyzerPlugin

###
Related Doc: package AnalyzerPlugins

#### trait AnalyzerPlugin extends AnyRef

Source
  AnalyzerPlugins.scala

Linear Supertypes
AnyRef, Any
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. AnalyzerPlugin
2. AnyRef
3. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Visibility

1. Public
2. All

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from Analyzer.AnalyzerPlugin to any2stringadd[Analyzer.AnalyzerPlugin] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (Analyzer.AnalyzerPlugin, B)

   Implicit information
     This member is added by an implicit conversion from Analyzer.AnalyzerPlugin to ArrowAssoc[Analyzer.AnalyzerPlugin] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   arg0

     the object to compare against this object for equality.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

6. #### def adaptAnnotations(tree: Global.Tree, typer: Analyzer.Typer, mode: Mode, pt: Global.Type): Global.Tree

   Adapt a tree that has an annotated type to the given type tp, taking into account the given mode (see method adapt in trait Typers).

   Adapt a tree that has an annotated type to the given type tp, taking into account the given mode (see method adapt in trait Typers).

   An implementation cannot rely on canAdaptAnnotations being called before. If the implementing class cannot do the adapting, it should return the tree unchanged.

7. #### final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown

     `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

8. #### def canAdaptAnnotations(tree: Global.Tree, typer: Analyzer.Typer, mode: Mode, pt: Global.Type): Boolean

   Decide whether this analyzer plugin can adapt a tree that has an annotated type to the given type tp, taking into account the given mode (see method adapt in trait Typers).

9. #### def clone(): AnyRef

   Create a copy of the receiver object.

   Create a copy of the receiver object.

   The default implementation of the `clone` method is platform dependent.

   returns

     a copy of the receiver object.

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws( ... )
   Note

     not specified by SLS as a member of AnyRef

10. #### def ensuring(cond: (Analyzer.AnalyzerPlugin) ⇒ Boolean, msg: ⇒ Any): Analyzer.AnalyzerPlugin

    Implicit information
      This member is added by an implicit conversion from Analyzer.AnalyzerPlugin to Ensuring[Analyzer.AnalyzerPlugin] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

11. #### def ensuring(cond: (Analyzer.AnalyzerPlugin) ⇒ Boolean): Analyzer.AnalyzerPlugin

    Implicit information
      This member is added by an implicit conversion from Analyzer.AnalyzerPlugin to Ensuring[Analyzer.AnalyzerPlugin] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

12. #### def ensuring(cond: Boolean, msg: ⇒ Any): Analyzer.AnalyzerPlugin

    Implicit information
      This member is added by an implicit conversion from Analyzer.AnalyzerPlugin to Ensuring[Analyzer.AnalyzerPlugin] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

13. #### def ensuring(cond: Boolean): Analyzer.AnalyzerPlugin

    Implicit information
      This member is added by an implicit conversion from Analyzer.AnalyzerPlugin to Ensuring[Analyzer.AnalyzerPlugin] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

14. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

15. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

16. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

17. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from Analyzer.AnalyzerPlugin to StringFormat[Analyzer.AnalyzerPlugin] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

18. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

19. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

20. #### def isActive(): Boolean

    Selectively activate this analyzer plugin, e.g.

    Selectively activate this analyzer plugin, e.g. according to the compiler phase.

    Note that the current phase can differ from the global compiler phase (look for `enteringPhase` invocations in the compiler). For instance, lazy types created by the UnPickler are completed at the phase in which their symbol is created. Observations show that this can even be the parser phase. Since symbol completion can trigger subtyping, typing etc, your plugin might need to be active also in phases other than namer and typer.

    Typically, this method can be implemented as

    global.phase.id < global.currentRun.picklerPhase.id

21. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

22. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

23. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

24. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

25. #### def pluginsPt(pt: Global.Type, typer: Analyzer.Typer, tree: Global.Tree, mode: Mode): Global.Type

    Let analyzer plugins change the expected type before type checking a tree.

26. #### def pluginsTypeSig(tpe: Global.Type, typer: Analyzer.Typer, defTree: Global.Tree, pt: Global.Type): Global.Type

    Let analyzer plugins change the types assigned to definitions.

    Let analyzer plugins change the types assigned to definitions. For definitions that have an annotated type, the assigned type is obtained by typing that type tree. Otherwise, the type is inferred by typing the definition's righthand side.

    In order to know if the type was inferred, you can query the `wasEmpty` field in the `tpt` TypeTree of the definition (for DefDef and ValDef).

    (*) If the type of a method or value is inferred, the type-checked tree is stored in the `analyzer.transformed` hash map, indexed by the definition's rhs tree.

    NOTE: Invoking the type checker can lead to cyclic reference errors. For instance, if this method is called from the type completer of a recursive method, type checking the method rhs will invoke the same completer again. It might be possible to avoid this situation by assigning `tpe` to `defTree.symbol` (untested) - the final type computed by this method will then be assigned to the definition's symbol by monoTypeCompleter (in Namers).

    The hooks into `typeSig` allow analyzer plugins to add annotations to (or change the types of) definition symbols. This cannot not be achieved by using `pluginsTyped`: this method is only called during type checking, so changing the type of a symbol at this point is too late: references to the symbol might already be typed and therefore obtain the the original type assigned during naming.

    defTree

      is the definition for which the type was computed. The different cases are outlined below. Note that this type is untyped (for methods and values with inferred type, the typed rhs trees are available in analyzer.transformed). Case defTree: Template

      - tpe : A ClassInfoType for the template
      - typer: The typer for template members, i.e. expressions and definitions of defTree.body
      - pt : WildcardType
      - the class symbol is accessible through typer.context.owner Case defTree: ClassDef
      - tpe : A ClassInfoType, or a PolyType(params, ClassInfoType) for polymorphic classes. The class type is the one computed by templateSig, i.e. through the above case
      - typer: The typer for the class. Note that this typer has a different context than the typer for the template.
      - pt : WildcardType Case defTree: ModuleDef
      - tpe : A ClassInfoType computed by templateSig
      - typer: The typer for the module. context.owner of this typer is the module class symbol
      - pt : WildcardType Case defTree: DefDef
      - tpe : The type of the method (MethodType, PolyType or NullaryMethodType). (*)
      - typer: The typer the rhs of this method
      - pt : If tpt.isEmpty, either the result type from the overridden method, or WildcardType. Otherwise the type obtained from typing tpt.
      - Note that for constructors, pt is the class type which the constructor creates. To type check the rhs of the constructor however, the expected type has to be WildcardType (see Typers.typedDefDef) Case defTree: ValDef
      - tpe : The type of this value. (*)
      - typer: The typer for the rhs of this value
      - pt : If tpt.isEmpty, WildcardType. Otherwise the type obtained from typing tpt.
      - Note that pluginsTypeSig might be called multiple times for the same ValDef since it is used to compute the types of the accessor methods (see `pluginsTypeSigAccessor`) Case defTree: TypeDef
      - tpe : The type obtained from typing rhs (PolyType if the TypeDef defines a polymorphic type)
      - typer: The typer for the rhs of this type
      - pt : WildcardType

27. #### def pluginsTypeSigAccessor(tpe: Global.Type, typer: Analyzer.Typer, tree: Global.ValDef, sym: Global.Symbol): Global.Type

    Modify the types of field accessors.

    Modify the types of field accessors. The namer phase creates method types for getters and setters based on the type of the corresponding field.

    Note: in order to compute the method type of an accessor, the namer calls `typeSig` on the `ValDef` tree of the corresponding field. This implies that the `pluginsTypeSig` method is potentially called multiple times for the same ValDef tree.

    tpe

      The method type created by the namer for the accessor

    typer

      The typer for the ValDef (not for the rhs)

    tree

      The ValDef corresponding to the accessor

    sym

      The accessor method symbol (getter, setter, beanGetter or beanSetter)

28. #### def pluginsTyped(tpe: Global.Type, typer: Analyzer.Typer, tree: Global.Tree, mode: Mode, pt: Global.Type): Global.Type

    Let analyzer plugins modify the type that has been computed for a tree.

    Let analyzer plugins modify the type that has been computed for a tree.

    tpe

      The type inferred by the type checker, initially (for first plugin) `tree.tpe`

    typer

      The yper that type checked `tree`

    tree

      The type-checked tree

    mode

      Mode that was used for typing `tree`

    pt

      Expected type that was used for typing `tree`

29. #### def pluginsTypedReturn(tpe: Global.Type, typer: Analyzer.Typer, tree: Global.Return, pt: Global.Type): Global.Type

    Modify the type of a return expression.

    Modify the type of a return expression. By default, return expressions have type NothingTpe.

    tpe

      The type of the return expression

    typer

      The typer that was used for typing the return tree

    tree

      The typed return expression tree

    pt

      The return type of the enclosing method

30. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

31. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

32. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

33. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

34. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

35. #### def →[B](y: B): (Analyzer.AnalyzerPlugin, B)

    Implicit information
      This member is added by an implicit conversion from Analyzer.AnalyzerPlugin to ArrowAssoc[Analyzer.AnalyzerPlugin] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from Analyzer.AnalyzerPlugin to any2stringadd[Analyzer.AnalyzerPlugin]

### Inherited by implicit conversion StringFormat from Analyzer.AnalyzerPlugin to StringFormat[Analyzer.AnalyzerPlugin]

### Inherited by implicit conversion Ensuring from Analyzer.AnalyzerPlugin to Ensuring[Analyzer.AnalyzerPlugin]

### Inherited by implicit conversion ArrowAssoc from Analyzer.AnalyzerPlugin to ArrowAssoc[Analyzer.AnalyzerPlugin]

### Ungrouped